!-------------------------------------------------------------------------------
program Dipest_Irreg

  use sep
	use puck_irreg

  implicit none

  integer :: n1, nd, ntwind, nnbr
	real    :: maxdist1, maxdist2, d1, d2, d3
	logical :: trace
  real, dimension(:,:),   pointer :: data, xy
  real, dimension(:,:,:), pointer :: dip

  call sep_init(SOURCE)

	call from_history( "n1", n1)
	call from_history( "n2", nd)
	call from_param( "d1", d1)
	call from_param( "ntwind", ntwind, 5)
	call from_param( "nneighbors", nnbr, min(nd,15) )

  allocate( data(n1,nd), xy(nd,2), dip(n1,nd,2) )

	call sep_read( data)
	call sep_read( xy, "xy")

	maxdist1 = abs( maxval(xy(:,1))-minval(xy(:,1)) )*0.25
	maxdist2 = abs( maxval(xy(:,2))-minval(xy(:,2)) )*0.25
	call from_param( "maxdist1", maxdist1, maxdist1)
	call from_param( "maxdist2", maxdist2, maxdist2)

	write(0,*) 'Dipest_Irreg: maxdist=',maxdist1,maxdist2
	write(0,*) 'xmax,xmin',maxval(xy(:,1)),minval(xy(:,1))
	write(0,*) 'ymax,ymin',maxval(xy(:,2)),minval(xy(:,2))

	call puck_irreg_init( xy, n1, ntwind, data, maxdist1, maxdist2, d1, nnbr)
	call puck_irreg( dip)

	call to_history( "n1", n1)
	call to_history( "n2", nd)
	call to_history( "n3", 2)

  call sep_write( dip)

	deallocate( data, xy, dip)

  call exit(0)

end program Dipest_Irreg
!-------------------------------------------------------------------------------
