!-------------------------------------------------------------------------------
! Takes a collection of traces in (x,y) space and converts to (ampl,t,x,y) form
!-------------------------------------------------------------------------------
program Trace2Irreg

  use sep

  implicit none

  real	  :: d1, o1, x, y, t
  integer :: n1, nd, ipt, id, i1, iign
  real, dimension(:,:), allocatable :: data_old, xy_old, axyz
	logical :: ignorezero

  call sep_init(SOURCE)
  call from_history( "n1", n1)
  call from_history( "d1", d1)
  call from_history( "o1", o1)
 	call from_history( "n2", nd)

	allocate( data_old(n1,nd), xy_old(nd,2), axyz(nd*n1,4) )

	call sep_read( data_old)
	call sep_read( xy_old, "xy" )
	call from_param( "ignorezero", iign, 0);  ignorezero=(iign==1)

	ipt = 1
	do id=1,nd
		if( ignorezero .AND. all(data_old(:,id)==0.0) ) cycle
		x = xy_old(id,1)
		y = xy_old(id,2)
		do i1=1,n1
			t = (i1-1)*d1 + o1
			axyz(ipt,1) = data_old(i1,id)
			axyz(ipt,2) = t
			axyz(ipt,3) = x
			axyz(ipt,4) = y
			ipt = ipt + 1
		end do
	end do

  call to_history( "n1", nd*n1)
  call to_history( "n2", 4)
  call to_history( "n3", 1)
  call to_history( "n4", 1)

  call sep_write( axyz )

	deallocate( data_old, axyz, xy_old)

  call exit(0)

end program Trace2Irreg
!-------------------------------------------------------------------------------
