#include "seperr.h"
/* #include "sepmain.h" */

#include <stdio.h>
#include <stdarg.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

void seperror( char *format, ... )
{
  va_list args;
  /*  char ** argv; */

  fflush(stdout);
  va_start(args,format);

  /* print out name of program causing error 
     if( (argv = separgv()) != NULL ) 
     fprintf( stderr, "%s: ", argv[0]); */

  /* print out remainder of message */
  vfprintf( stderr, format, args );
  va_end(args);

  /* if format ends with ':', print system information */
  if (format[0] != '\0' && format[strlen(format)-1] == ':')
    fprintf (stderr, " %s", strerror(errno));

  fprintf (stderr, "\n");
  exit(EXIT_FAILED); /* failed execution */
}

void sepwarning( char *format, ... )
{
  va_list args;
  /*  char ** argv; */

  fflush(stdout);
  va_start(args,format);

  /* print out name of program causing error 
     if( (argv = separgv()) != NULL ) 
     fprintf( stderr, "%s: ", argv[0]); */

  /* print out remainder of message */
  vfprintf( stderr, format, args );
  va_end(args);

  /* if format ends with ':', print system information */
  if (format[0] != '\0' && format[strlen(format)-1] == ':')
    fprintf (stderr, " %s", strerror(errno));

  fprintf (stderr, "\n");
}

void *sepalloc (int n, size_t size)
{
  void *ptr; 
  
  ptr = malloc (n*size);
  if (ptr == NULL)
    seperror ("alloc(sep):can't allocate %d bytes:", n*size);
  return ptr;
}

void **sepalloc2 (int n1, int n2, size_t size)
{
  void **ptr;
  int i2;
  
  ptr = (void**) malloc (n2*sizeof(void*));
  if (ptr == NULL)
    seperror ("alloc(sep):can't allocate %d bytes:", n2*sizeof(void*));

  for (i2=0; i2 < n2; i2++) {
    ptr[i2] = sepalloc (n1,size);
  }

  return ptr;
}

void ***sepalloc3 (int n1, int n2, int n3, size_t size)
{
  void ***ptr;
  int i3;
  
  ptr = (void***) malloc (n3*sizeof(void**));
  if (ptr == NULL)
    seperror ("alloc(sep):can't allocate %d bytes:", n3*sizeof(void**));

  for (i3=0; i3 < n3; i3++) {
    ptr[i3] = sepalloc2 (n1,n2,size);
  }

  return ptr;
}

void free2 (int n2, void** p)
{
  int i2;

  for (i2=0; i2 < n2; i2++) {
    free (p[i2]);
  }
  free (p);
}

void free3 (int n3, int n2, void*** p)
{
  int i3;

  for (i3=0; i3 < n3; i3++) {
    free2 (n2, p[i3]);
  }
  free (p);
}



